### Method

# FwupdPlugin HeciDevice read_file_ex

since: 2.0.9

#### Declaration [src]

    GByteArray*
    fu_heci_device_read_file_ex (
      FuHeciDevice* self,
      guint32 file_id,
      guint32 section,
      guint32 datasz_req,
      GError** error
    )

#### Description [src]

Reads a file from the MFS.

Available since: 2.0.9

#### Parameters

`file_id`

  Type: `guint32`

  MFS file ID.

`section`

  Type: `guint32`

  MFS section.

`datasz_req`

  Type: `guint32`

  The maximum size of data to request.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guint8`

File data.

The caller of the method takes ownership of the data container, but not the data inside it.